#include <stdlib.h>
#include <string.h>
#include <alloca.h>
/* number of function calls to get usefull gprof timings */
#define LOOPCOUNT 100000000


/* allocate memory and performe one write action to buffer for heap and stack */
void stack_buffer()
{
	char buffer[20];
	strcpy(buffer,"hello world");
}

void heap_buffer()
{
	char *buffer;
	buffer = (char*)malloc(20 * sizeof(char));
	strcpy(buffer,"hello world");
	free(buffer);
}

void alloca_buffer()
{
	char *buffer;
	buffer = alloca(20 * sizeof(char));
	strcpy(buffer,"hello world");
}


int main(int argc, char *argv[])
{
	for(int i = 0; i < LOOPCOUNT; i++){
		stack_buffer();
		heap_buffer();
		alloca_buffer();
	}
	return 0;
}
